/* (c) Copyright 2001 Josh Levenberg */

/* Math/Geometric algorithms */

#ifndef __GL_SW_GLSW_MATH_H
#define __GL_SW_GLSW_MATH_H

/* for "bool" */
#include "types.h"

double DegreesToRadians(float foo);

/* Scales a vector to length 1.  Changes v! */
void NormalizeVector(float v[3]);

float DotProduct(float v1[3], float v2[3]);

/* Computes out_v = v1 x v2.  Changes out_v! */
void CrossProduct(float v1[3], float v2[3], float out_v[3]);

/* Finds the intersection of a ray with a plane */
/* Changes "result" */
/* see glswmath.c for a picture */
bool RayPlaneIntersection(float pos[3], float dir[3], float normal[3], 
                          float offset, float result[3]);

/* Returns a number from 0..n-1 */
int Random(int n);

/* Returns a floating point number from 0..1 (not including 1) */
float FRand(void);

/* Tests to see if a line intersects a sphere, and computes the
   earliest intersection point.  Used to see if lasers hit things. 
 */
/* Changes "out_closestpt" */
/* Assumes linedir is normalized */
bool LineSphereIntersect(float linepos[3], float linedir[3], 
                        float center[3], float radiussquared, 
                        float out_closestpt[3]);

#endif /* #ifndef __GL_SW_GLSW_MATH_H */
