/* (c) Copyright 2001 Josh Levenberg */

#ifndef __GL_SW_GLUT_MAIN_H
#define __GL_SW_GLUT_MAIN_H

/* for "voidfunc" */
#include "types.h"

/* GlutState is just a structure with a bunch of callbacks.
   When SwitchToGlutState is called, it registers these callbacks
   with GLUT.  "init" and "close" are different: they are called
   when the GlutState has been selected/deselected.
 */
typedef void (*kbdfunc)(unsigned char key, int x, int y);
typedef void (*clickfunc)(int button, int state, int x, int y);
typedef void (*movefunc)(int x, int y);

typedef struct GlutState_TAG
  {
    voidfunc init;
    voidfunc close;
    voidfunc draw;
    voidfunc idle;
    clickfunc mouseclick;
    movefunc  mousemove;
  } GlutState;

/* SwitchToGlutState(0) disables callbacks.  This is done when
   the window is minimized.
 */
void SwitchToGlutState(GlutState *newstate);

/* Window size */
extern int gWidth;
extern int gHeight;
/* Vertical field of view in degrees */
extern float gFov;
/* Near/far clip plane distances */
extern float gNear;
extern float gFar;

/* Calls "printf" if there is an OpenGL error.  Should call
   this periodically to make sure everything is OK.
 */
bool CheckForGLError(const char *where);

#endif /* #ifndef __GL_SW_GLUT_MAIN_H */