/* (c) Copyright 2001 Josh Levenberg */

/* Responsible for all changes to the world state
   (though it does delegate some of this responsibilty
   to the collision detection module)
 */

#ifndef __GL_SW_PHYSICS_H
#define __GL_SW_PHYSICS_H

/* Set up the world, start a fresh game */
void PhysicsInit(int level);

/* Advance the world clock, almost all game play rules are in here */
void PhysicsAdvance(double timestep);

/* Called when the player fires lasers.  Fires in the direction
   of the current 'aim.'
 */
void PhysicsFire(void);

/* Called when the player moves the cursor */
void PhysicsAim(float x, float z);

#endif /* #ifndef __GL_SW_PHYSICS_H */
