/* (c) Copyright 2001 Josh Levenberg */

/* Render text using GLUT's stroke fonts.
   Would be nice to support TrueType, but
   that's too much work for this little game.
 */

#include <GL/glut.h>
#include "text.h"

char gMessageBuffers[2][64];

/* Stroke font */
#define MESSAGE_FONT GLUT_STROKE_ROMAN

void CenterText(const char *msg, float scale, float y, float z)
  {
    const char *msgptr;
    int msgwid=0;
    float msgscrnwid;
    for (msgptr=msg; *msgptr; ++msgptr)
      msgwid+=glutStrokeWidth(MESSAGE_FONT, *msgptr);
    msgscrnwid = msgwid*scale;
    glPushMatrix();
    glTranslatef(-.5f*msgscrnwid, y, z);
    glRotatef(90, 1, 0, 0);
    glScalef(scale, scale, scale);
    for (msgptr=msg; *msgptr; ++msgptr)
      glutStrokeCharacter(MESSAGE_FONT, *msgptr);
    glPopMatrix();
  }

void CornerText(const char *msg, float scale, bool right, float x, float z)
  {
    const char *msgptr;
    int msgwid=0;
    float msgscrnwid;
    for (msgptr=msg; *msgptr; ++msgptr)
      msgwid+=glutStrokeWidth(MESSAGE_FONT, *msgptr);
    msgscrnwid = msgwid*scale;
    glPushMatrix();
    if (right)
      glTranslatef(x-msgscrnwid, 1, z);
    else
      glTranslatef(-x, 1, z);
    glRotatef(90, 1, 0, 0);
    glScalef(scale, scale, scale);
    for (msgptr=msg; *msgptr; ++msgptr)
      glutStrokeCharacter(MESSAGE_FONT, *msgptr);
    glPopMatrix();
  }
